﻿using System.Windows.Forms;
using ControlWrapsPoC.Samples;

namespace ControlWrapsPoC
{
    public partial class MainForm : Form
    {
        public MainForm()
        {
            InitializeComponent();

            var samples = new Form[]
            {
                new ToolTipSampleForm(),
                new LoadingSampleForm(),
                new DateTimePickerSampleForm(),
                new ParallelSlideBarSampleForm(), 
            };

            foreach (var item in samples)
            {
                var page = new TabPage(item.Text);
                item.TopLevel = false;
                page.Controls.Add(item);
                MainTabControl.TabPages.Add(page);

                item.Dock = DockStyle.Fill;
                item.FormBorderStyle = FormBorderStyle.None;
                item.Show();
            }
        }
    }
}