﻿using System;
using System.Linq;
using System.Windows.Forms;
using ControlWrapsPoC.Wraps;

namespace ControlWrapsPoC.Samples
{
    public partial class ToolTipSampleForm : Form
    {
        public ToolTipSampleForm()
        {
            InitializeComponent();
            IconComboBox.DataSource = Enum.GetValues(typeof(ToolTipIcon));
            ControlsComboBox.DisplayMember = "Name";
            ControlsComboBox.ValueMember = "Control";
            ControlsComboBox.DataSource = Controls.Cast<Control>().Select(p => new { p.Name, Control = p }).ToArray();
        }

        private void BalloonButton_Click(object sender, EventArgs e)
        {
            var icon = (ToolTipIcon)IconComboBox.SelectedValue;
            var ctrl = (Control)ControlsComboBox.SelectedValue;

            NativeToolTip.ToolTipTitle = TitleTextBox.Text;
            NativeToolTip.ToolTipIcon = icon;
            NativeToolTip.IsBalloon = BalloonCheckBox.Checked;

            if (PositionCheckBox.Checked) NativeToolTip.Show(ContentTextBox.Text, ctrl, (int)XUpDown.Value, (int)YUpDown.Value);
            else NativeToolTip.Show(ContentTextBox.Text, ctrl);
        }

        private void ShowToolTipWrapButton_Click(object sender, EventArgs e)
        {
            var icon = (ToolTipIcon)IconComboBox.SelectedValue;
            var ctrl = (Control)ControlsComboBox.SelectedValue;

            if (PositionCheckBox.Checked) ToolTipWrap.Show((int)DurationUpDown.Value, BalloonCheckBox.Checked, icon, TitleTextBox.Text, ContentTextBox.Text, ctrl, (int)XUpDown.Value, (int)YUpDown.Value);
            else ToolTipWrap.Show((int)DurationUpDown.Value, BalloonCheckBox.Checked, icon, TitleTextBox.Text, ContentTextBox.Text, ctrl);
        }
    }
}