﻿using System;
using System.Linq.Expressions;

namespace FormulaEnginePoC.DynamicExpressionParse
{
    public static class FormulaCompiler
    {
        public static Func<TSource, TResult> Compile<TSource, TResult>(string expression)
        {
            var lam = DynamicExpression.ParseLambda(
                new[] { Expression.Parameter(typeof(TSource), "p") }
                , typeof(TResult)
                , expression
            );

            return (Func<TSource, TResult>)lam.Compile();
        }
    }
}