﻿using System;
using System.Windows.Forms;

namespace FormulaEnginePoC.UI
{
    public partial class CodeExecPanel : UserControl
    {
        public CodeExecPanel()
        {
            Dock = DockStyle.Fill;
            InitializeComponent();
        }

        public string Code { get => CodeTextBox.Text; set => CodeTextBox.Text = value; }

        public string Result { get => ResultTextBox.Text; set => ResultTextBox.Text = value; }

        public event EventHandler CompileButtonClicked;

        public event EventHandler ExecuteButtonClicked;

        private void CompileToolStripButton_Click(object sender, EventArgs e)
        {
            OnCompileButtonClicked();
        }

        private void ExecuteToolStripButton_Click(object sender, EventArgs e)
        {
            OnExecuteButtonClicked();
        }

        protected virtual void OnCompileButtonClicked()
        {
            CompileButtonClicked?.Invoke(this, EventArgs.Empty);
        }

        protected virtual void OnExecuteButtonClicked()
        {
            ExecuteButtonClicked?.Invoke(this, EventArgs.Empty);
        }
    }
}
